#!/usr/bin/perl
###############################################################################

use File::Find;

@ARGV = qw(.) unless @ARGV;

my %authors;

sub find_authors
{
	$file = $_;

	return if (-d $file);
	return if ($file !~ /,v$/);

	print STDERR "processing \"$file\" ... ";

	open (FILE, "<$file") || die;
	@matchlines = grep { /;	author / } <FILE>;
	close (FILE);

	print STDERR "grep done ... ";

	foreach $line (@matchlines)
	{
		if ($line =~ /author ([^;]*);/)
		{
			$authors{$1}++;
		}
	}

	print STDERR "search done\n";
}

find (\&find_authors, @ARGV);

print STDERR "=============================================================\n";

foreach $name (sort keys %authors)
{
	#print "$name occurs $authors{$name} times\n";
	print "$name\t\t$name\n";
}
